diff -uNr nagios-plugins-1.4.11/plugins-root/check_dhcp.c nagios-plugins-1.4.12/plugins-root/check_dhcp.c
--- nagios-plugins-1.4.11/plugins-root/check_dhcp.c	2007-10-25 22:43:04.000000000 +0200
+++ nagios-plugins-1.4.12/plugins-root/check_dhcp.c	2008-05-07 12:02:42.000000000 +0200
@@ -1,49 +1,44 @@
-/******************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios check_dhcp plugin
-*
+* 
 * License: GPL
 * Copyright (c) 2001-2004 Ethan Galstad (nagios@nagios.org)
-* Copyright (c) 2001-2006 Nagios Plugin Development Team
-*
-* Last Modified: $Date: 2007-10-25 21:43:04 +0100 (Thu, 25 Oct 2007) $
-*
+* Copyright (c) 2001-2007 Nagios Plugin Development Team
+* 
+* Last Modified: $Date: 2008-05-07 11:02:42 +0100 (Wed, 07 May 2008) $
+* 
 * Description:
-*
+* 
 * This file contains the check_dhcp plugin
-*
-*  This plugin tests the availability of DHCP servers on a network.
-*
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* This plugin tests the availability of DHCP servers on a network.
+* 
+* Unicast mode was originally implemented by Heiti of Boras Kommun with
+* general improvements as well as usability fixes and "forward"-porting by
+* Andreas Ericsson of OP5 AB.
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-* $Id: check_dhcp.c 1810 2007-10-25 20:43:04Z tonvoon $
-*
-* ------------------------------------------------------------------------
-* Unicast mode was originally implemented by Heiti of Boras Kommun with
-* general improvements as well as usability fixes and "forward"-porting by
-* Andreas Ericsson of OP5 AB.
-* ------------------------------------------------------------------------
-*
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: check_dhcp.c 1991 2008-05-07 10:02:42Z dermoth $
+* 
 *****************************************************************************/
 
 const char *progname = "check_dhcp";
-const char *revision = "$Revision: 1810 $";
-const char *copyright = "2001-2006";
+const char *revision = "$Revision: 1991 $";
+const char *copyright = "2001-2007";
 const char *email = "nagiosplug-devel@lists.sourceforge.net";
 
 #include "common.h"
@@ -273,13 +268,16 @@
 	bindtextdomain (PACKAGE, LOCALEDIR);
 	textdomain (PACKAGE);
 
+	/* Parse extra opts if any */
+	argv=np_extra_opts(&argc, argv, progname);
+
 	if(process_arguments(argc,argv)!=OK){
 		usage4 (_("Could not parse arguments"));
 		}
 
 	/* this plugin almost certainly needs root permissions. */
 	np_warn_if_not_root();
-	
+
 	/* create socket for DHCP communications */
 	dhcp_socket=create_dhcp_socket();
 
@@ -321,7 +319,7 @@
 
 	strncpy((char *)&ifr.ifr_name,interface_name,sizeof(ifr.ifr_name)-1);
 	ifr.ifr_name[sizeof(ifr.ifr_name)-1]='\0';
-	
+
 	/* try and grab hardware address of requested interface */
 	if(ioctl(sock,SIOCGIFHWADDR,&ifr)<0){
                 printf(_("Error: Could not get hardware address of interface '%s'\n"),interface_name);
@@ -511,7 +509,7 @@
 		opts += sizeof(requested_address);
 	        }
 	discover_packet.options[opts++]=DHCP_OPTION_END;
-	
+
 	/* unicast fields */
 	if(unicast)
 		discover_packet.giaddr.s_addr = my_ip.s_addr;
@@ -576,7 +574,7 @@
 
 		result=OK;
 		result=receive_dhcp_packet(&offer_packet,sizeof(offer_packet),sock,dhcpoffer_timeout,&source);
-		
+
 		if(result!=OK){
 			if(verbose)
 				printf(_("Result=ERROR\n"));
@@ -957,7 +955,7 @@
 		next_server=this_server->next;
 		free(this_server);
 	        }
-	
+
 	return OK;
         }
 
@@ -982,7 +980,7 @@
 				/* get max lease time we were offered */
 				if(temp_offer->lease_time>max_lease_time || temp_offer->lease_time==DHCP_INFINITE_TIME)
 					max_lease_time=temp_offer->lease_time;
-				
+
 				/* see if we got the address we requested */
 				if(!memcmp(&requested_address,&temp_offer->offered_address,sizeof(requested_address)))
 					received_requested_address=TRUE;
@@ -1014,7 +1012,7 @@
 			/* get max lease time we were offered */
 			if(temp_offer->lease_time>max_lease_time || temp_offer->lease_time==DHCP_INFINITE_TIME)
 				max_lease_time=temp_offer->lease_time;
-				
+
 			/* see if we got the address we requested */
 			if(!memcmp(&requested_address,&temp_offer->offered_address,sizeof(requested_address)))
 				received_requested_address=TRUE;
@@ -1392,7 +1390,7 @@
 
 	printf("Copyright (c) 2001-2004 Ethan Galstad (nagios@nagios.org)\n");
 	printf (COPYRIGHT, copyright, email);
-	
+
 	printf("%s\n", _("This plugin tests the availability of DHCP servers on a network."));
 
   printf ("\n\n");
@@ -1400,6 +1398,7 @@
 	print_usage();
 
 	printf (_(UT_HELP_VRSN));
+	printf (_(UT_EXTRA_OPTS));
 
 	printf (_(UT_VERBOSE));
 
@@ -1416,17 +1415,24 @@
   printf (" %s\n", "-u, --unicast");
   printf ("    %s\n", _("Unicast testing: mimic a DHCP relay, requires -s"));
 
+#ifdef NP_EXTRA_OPTS
+  printf ("\n");
+  printf ("%s\n", _("Notes:"));
+  printf (_(UT_EXTRA_OPTS_NOTES));
+#endif
+
+  printf (_(UT_SUPPORT));
 	return;
 	}
 
 
 void
 print_usage(void){
-	
+
   printf (_("Usage:"));
   printf (" %s [-v] [-u] [-s serverip] [-r requestedip] [-t timeout]\n",progname);
   printf ("                  [-i interface] [-m mac]\n");
-  
+
 	return;
 	}
 
diff -uNr nagios-plugins-1.4.11/plugins-root/check_icmp.c nagios-plugins-1.4.12/plugins-root/check_icmp.c
--- nagios-plugins-1.4.11/plugins-root/check_icmp.c	2007-12-11 06:57:35.000000000 +0100
+++ nagios-plugins-1.4.12/plugins-root/check_icmp.c	2008-05-07 12:02:42.000000000 +0200
@@ -1,52 +1,49 @@
- /******************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios check_icmp plugin
-*
+* 
 * License: GPL
-* Copyright (c) 2005-2007 nagios-plugins team
-*
+* Copyright (c) 2005-2008 Nagios Plugins Development Team
 * Original Author : Andreas Ericsson <ae@op5.se>
-*
-* Last Modified: $Date: 2007-12-11 05:57:35 +0000 (Tue, 11 Dec 2007) $
-*
+* 
+* Last Modified: $Date: 2008-05-07 11:02:42 +0100 (Wed, 07 May 2008) $
+* 
 * Description:
-*
+* 
 * This file contains the check_icmp plugin
-*
-*  Relevant RFC's: 792 (ICMP), 791 (IP)
-*
-*  This program was modeled somewhat after the check_icmp program,
-*  which was in turn a hack of fping (www.fping.org) but has been
-*  completely rewritten since to generate higher precision rta values,
-*  and support several different modes as well as setting ttl to control.
-*  redundant routes. The only remainders of fping is currently a few
-*  function names.
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* Relevant RFC's: 792 (ICMP), 791 (IP)
+* 
+* This program was modeled somewhat after the check_icmp program,
+* which was in turn a hack of fping (www.fping.org) but has been
+* completely rewritten since to generate higher precision rta values,
+* and support several different modes as well as setting ttl to control.
+* redundant routes. The only remainders of fping is currently a few
+* function names.
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-* $Id: check_icmp.c 1861 2007-12-11 05:57:35Z dermoth $
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: check_icmp.c 1991 2008-05-07 10:02:42Z dermoth $
 * 
 *****************************************************************************/
 
 /* progname may change */
 /* char *progname = "check_icmp"; */
 char *progname;
-const char *revision = "$Revision: 1861 $";
-const char *copyright = "2005-2007";
+const char *revision = "$Revision: 1991 $";
+const char *copyright = "2005-2008";
 const char *email = "nagiosplug-devel@lists.sourceforge.net";
 
 /** nagios plugins basic includes */
@@ -54,6 +51,10 @@
 #include "netutils.h"
 #include "utils.h"
 
+#if HAVE_SYS_SOCKIO_H
+#include <sys/sockio.h>
+#endif
+#include <sys/ioctl.h>
 #include <sys/time.h>
 #include <sys/types.h>
 #include <stdio.h>
@@ -66,6 +67,7 @@
 #include <ctype.h>
 #include <netdb.h>
 #include <sys/socket.h>
+#include <net/if.h>
 #include <netinet/in_systm.h>
 #include <netinet/in.h>
 #include <netinet/ip.h>
@@ -79,7 +81,7 @@
 # define MAXTTL	255
 #endif
 #ifndef INADDR_NONE
-# define INADDR_NONE 0xffffffU
+# define INADDR_NONE (in_addr_t)(-1)
 #endif
 
 #ifndef SOL_IP
@@ -178,14 +180,16 @@
 void print_usage (void);
 static u_int get_timevar(const char *);
 static u_int get_timevaldiff(struct timeval *, struct timeval *);
+static in_addr_t get_ip_address(const char *);
 static int wait_for_reply(int, u_int);
 static int recvfrom_wto(int, char *, unsigned int, struct sockaddr *, u_int *);
 static int send_icmp_ping(int, struct rta_host *);
 static int get_threshold(char *str, threshold *th);
 static void run_checks(void);
+static void set_source_ip(char *);
 static int add_target(char *);
 static int add_target_ip(char *, struct in_addr *);
-static int handle_random_icmp(struct icmp *, struct sockaddr_in *);
+static int handle_random_icmp(char *, struct sockaddr_in *);
 static unsigned short icmp_checksum(unsigned short *, int);
 static void finish(int);
 static void crash(const char *, ...);
@@ -235,10 +239,10 @@
 }
 
 
-static char *
+static const char *
 get_icmp_error_msg(unsigned char icmp_type, unsigned char icmp_code)
 {
-	char *msg = "unreachable";
+	const char *msg = "unreachable";
 
 	if(debug > 1) printf("get_icmp_error_msg(%u, %u)\n", icmp_type, icmp_code);
 	switch(icmp_type) {
@@ -292,19 +296,18 @@
 }
 
 static int
-handle_random_icmp(struct icmp *p, struct sockaddr_in *addr)
+handle_random_icmp(char *packet, struct sockaddr_in *addr)
 {
-	struct icmp sent_icmp;
+	struct icmp p, sent_icmp;
 	struct rta_host *host = NULL;
-	unsigned char *ptr;
 
-	if(p->icmp_type == ICMP_ECHO && p->icmp_id == pid) {
+	memcpy(&p, packet, sizeof(p));
+	if(p.icmp_type == ICMP_ECHO && p.icmp_id == pid) {
 		/* echo request from us to us (pinging localhost) */
 		return 0;
 	}
 
-	ptr = (unsigned char *)p;
-	if(debug) printf("handle_random_icmp(%p, %p)\n", (void *)p, (void *)addr);
+	if(debug) printf("handle_random_icmp(%p, %p)\n", (void *)&p, (void *)addr);
 
 	/* only handle a few types, since others can't possibly be replies to
 	 * us in a sane network (if it is anyway, it will be counted as lost
@@ -316,15 +319,15 @@
 	 * TIMXCEED actually sends a proper icmp response we will have passed
 	 * too many hops to have a hope of reaching it later, in which case it
 	 * indicates overconfidence in the network, poor routing or both. */
-	if(p->icmp_type != ICMP_UNREACH && p->icmp_type != ICMP_TIMXCEED &&
-	   p->icmp_type != ICMP_SOURCEQUENCH && p->icmp_type != ICMP_PARAMPROB)
+	if(p.icmp_type != ICMP_UNREACH && p.icmp_type != ICMP_TIMXCEED &&
+	   p.icmp_type != ICMP_SOURCEQUENCH && p.icmp_type != ICMP_PARAMPROB)
 	{
 		return 0;
 	}
 
 	/* might be for us. At least it holds the original package (according
 	 * to RFC 792). If it isn't, just ignore it */
-	memcpy(&sent_icmp, ptr + 28, sizeof(sent_icmp));
+	memcpy(&sent_icmp, packet + 28, sizeof(sent_icmp));
 	if(sent_icmp.icmp_type != ICMP_ECHO || sent_icmp.icmp_id != pid ||
 	   sent_icmp.icmp_seq >= targets)
 	{
@@ -336,7 +339,7 @@
 	host = table[sent_icmp.icmp_seq];
 	if(debug) {
 		printf("Received \"%s\" from %s for ICMP ECHO sent to %s.\n",
-			   get_icmp_error_msg(p->icmp_type, p->icmp_code),
+			   get_icmp_error_msg(p.icmp_type, p.icmp_code),
 			   inet_ntoa(addr->sin_addr), host->name);
 	}
 
@@ -347,7 +350,7 @@
 
 	/* source quench means we're sending too fast, so increase the
 	 * interval and mark this packet lost */
-	if(p->icmp_type == ICMP_SOURCEQUENCH) {
+	if(p.icmp_type == ICMP_SOURCEQUENCH) {
 		pkt_interval *= pkt_backoff_factor;
 		target_interval *= target_backoff_factor;
 	}
@@ -355,8 +358,8 @@
 		targets_down++;
 		host->flags |= FLAG_LOST_CAUSE;
 	}
-	host->icmp_type = p->icmp_type;
-	host->icmp_code = p->icmp_code;
+	host->icmp_type = p.icmp_type;
+	host->icmp_code = p.icmp_code;
 	host->error_addr.s_addr = addr->sin_addr.s_addr;
 
 	return 0;
@@ -375,7 +378,7 @@
 	setlocale (LC_ALL, "");
 	bindtextdomain (PACKAGE, LOCALEDIR);
 	textdomain (PACKAGE);
-	
+
 	/* print a helpful error message if geteuid != 0 */
 	np_warn_if_not_root();
 
@@ -444,9 +447,12 @@
 		packets = 5;
 	}
 
+	/* Parse extra opts if any */
+	argv=np_extra_opts(&argc, argv, progname);
+
 	/* parse the arguments */
 	for(i = 1; i < argc; i++) {
-		while((arg = getopt(argc, argv, "vhVw:c:n:p:t:H:i:b:I:l:m:")) != EOF) {
+		while((arg = getopt(argc, argv, "vhVw:c:n:p:t:H:s:i:b:I:l:m:")) != EOF) {
 			switch(arg) {
 			case 'v':
 				debug++;
@@ -489,6 +495,9 @@
 					crit_down = (unsigned char)strtoul(ptr + 1, NULL, 0);
 				}
 				break;
+			case 's': /* specify source IP address */
+				set_source_ip(optarg);
+				break;
       case 'V':                 /* version */
         /*print_revision (progname, revision);*/ /* FIXME: Why? */
         exit (STATE_OK);
@@ -640,7 +649,7 @@
 								 table[t]->name);
 				continue;
 			}
-			
+
 			/* we're still in the game, so send next packet */
 			(void)send_icmp_ping(icmp_sock, table[t]);
 			result = wait_for_reply(icmp_sock, target_interval);
@@ -748,13 +757,13 @@
 		memcpy(&icp, buf + hlen, sizeof(icp));
 
 		if(icp.icmp_id != pid) {
-			handle_random_icmp(&icp, &resp_addr);
+			handle_random_icmp(buf + hlen, &resp_addr);
 			continue;
 		}
 
 		if(icp.icmp_type != ICMP_ECHOREPLY || icp.icmp_seq >= targets) {
 			if(debug > 2) printf("not a proper ICMP_ECHOREPLY\n");
-			handle_random_icmp(&icp, &resp_addr);
+			handle_random_icmp(buf + hlen, &resp_addr);
 			continue;
 		}
 
@@ -887,7 +896,7 @@
 	unsigned char pl;
 	double rta;
 	struct rta_host *host;
-	char *status_string[] =
+	const char *status_string[] =
 	{"OK", "WARNING", "CRITICAL", "UNKNOWN", "DEPENDENT"};
 	int hosts_ok = 0;
 	int hosts_warn = 0;
@@ -1101,7 +1110,7 @@
 
 		/* this is silly, but it works */
 		if(mode == MODE_HOSTCHECK || mode == MODE_ALL) {
-			printf("mode: %d\n", mode);
+			if(debug > 2) printf("mode: %d\n", mode);
 			continue;
 		}
 		break;
@@ -1109,6 +1118,40 @@
 
 	return 0;
 }
+
+static void
+set_source_ip(char *arg)
+{
+	struct sockaddr_in src;
+
+	memset(&src, 0, sizeof(src));
+	src.sin_family = AF_INET;
+	if((src.sin_addr.s_addr = inet_addr(arg)) == INADDR_NONE)
+		src.sin_addr.s_addr = get_ip_address(arg);
+	if(bind(icmp_sock, (struct sockaddr *)&src, sizeof(src)) == -1)
+		crash("Cannot bind to IP address %s", arg);
+}
+
+/* TODO: Move this to netutils.c and also change check_dhcp to use that. */
+static in_addr_t
+get_ip_address(const char *ifname)
+{
+#if defined(SIOCGIFADDR)
+	struct ifreq ifr;
+	struct sockaddr_in ip;
+
+	strncpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name) - 1);
+	ifr.ifr_name[sizeof(ifr.ifr_name) - 1] = '\0';
+	if(ioctl(icmp_sock, SIOCGIFADDR, &ifr) == -1)
+		crash("Cannot determine IP address of interface %s", ifname);
+	memcpy(&ip, &ifr.ifr_addr, sizeof(ip));
+	return ip.sin_addr.s_addr;
+#else
+	errno = 0;
+	crash("Cannot get interface IP address on this platform.");
+#endif
+}
+
 /*
  * u = micro
  * m = milli
@@ -1213,16 +1256,17 @@
 {
 
   /*print_revision (progname, revision);*/ /* FIXME: Why? */
-  
+
   printf ("Copyright (c) 2005 Andreas Ericsson <ae@op5.se>\n");
   printf (COPYRIGHT, copyright, email);
-  
+
   printf ("\n\n");
-  
+
   print_usage ();
-  
+
   printf (_(UT_HELP_VRSN));
-  
+  printf (_(UT_EXTRA_OPTS));
+
   printf (" %s\n", "-H");
   printf ("    %s\n", _("specify a target"));
   printf (" %s\n", "-w");
@@ -1231,6 +1275,8 @@
   printf (" %s\n", "-c");
   printf ("    %s", _("critical threshold (currently "));
   printf ("%0.3fms,%u%%)\n", (float)crit.rta, crit.pl);
+  printf (" %s\n", "-s");
+  printf ("    %s\n", _("specify a source IP address or device name"));
   printf (" %s\n", "-n");
   printf ("    %s", _("number of packets to send (currently "));
   printf ("%u)\n",packets);
@@ -1255,23 +1301,28 @@
   printf ("    %s\n", _("verbose"));
 
   printf ("\n");
-	printf ("%s\n\n", _("The -H switch is optional. Naming a host (or several) to check is not."));
-  printf ("%s\n", _("Threshold format for -w and -c is 200.25,60% for 200.25 msec RTA and 60%"));
-  printf ("%s\n", _("packet loss.  The default values should work well for most users."));
-  printf ("%s\n", _("You can specify different RTA factors using the standardized abbreviations"));
-  printf ("%s\n\n", _("us (microseconds), ms (milliseconds, default) or just plain s for seconds."));
+  printf ("%s\n", _("Notes:"));
+  printf (" %s\n", _("The -H switch is optional. Naming a host (or several) to check is not."));
+  printf ("\n");
+  printf (" %s\n", _("Threshold format for -w and -c is 200.25,60% for 200.25 msec RTA and 60%"));
+  printf (" %s\n", _("packet loss.  The default values should work well for most users."));
+  printf (" %s\n", _("You can specify different RTA factors using the standardized abbreviations"));
+  printf (" %s\n", _("us (microseconds), ms (milliseconds, default) or just plain s for seconds."));
 /* -d not yet implemented */
 /*  printf ("%s\n", _("Threshold format for -d is warn,crit.  12,14 means WARNING if >= 12 hops"));
   printf ("%s\n", _("are spent and CRITICAL if >= 14 hops are spent."));
   printf ("%s\n\n", _("NOTE: Some systems decrease TTL when forming ICMP_ECHOREPLY, others do not."));*/
-  printf ("%s\n\n", _("The -v switch can be specified several times for increased verbosity."));
-
+  printf ("\n");
+  printf (" %s\n", _("The -v switch can be specified several times for increased verbosity."));
 /*  printf ("%s\n", _("Long options are currently unsupported."));
   printf ("%s\n", _("Options marked with * require an argument"));
 */
+#ifdef NP_EXTRA_OPTS
+  printf ("\n");
+  printf (_(UT_EXTRA_OPTS_NOTES));
+#endif
+
   printf (_(UT_SUPPORT));
-  
-  printf (_(UT_NOWARRANTY));
 }
 
 
@@ -1280,5 +1331,5 @@
 print_usage (void)
 {
   printf (_("Usage:"));
-  printf(" %s [options] [-H] host1 host2 hostn\n", progname);
+  printf(" %s [options] [-H] host1 host2 hostN\n", progname);
 }
diff -uNr nagios-plugins-1.4.11/plugins-root/Makefile.am nagios-plugins-1.4.12/plugins-root/Makefile.am
--- nagios-plugins-1.4.11/plugins-root/Makefile.am	2007-12-13 23:22:27.000000000 +0100
+++ nagios-plugins-1.4.12/plugins-root/Makefile.am	2008-03-14 16:44:27.000000000 +0100
@@ -4,10 +4,10 @@
 
 INCLUDES = -I.. -I$(top_srcdir)/lib -I$(top_srcdir)/gl -I$(top_srcdir)/intl -I$(top_srcdir)/plugins @SSLINCLUDE@
 
-datadir = @datadir@
 localedir = $(datadir)/locale
 DEFS = -DLOCALEDIR=\"$(localedir)\" @DEFS@
-LIBS = @LIBINTL@ @LIBS@ @SSLLIBS@
+# Don't add LTLIBINTL to all, as pst3 doesn't need it
+#LIBS = @LTLIBINTL@ @LIBS@
 
 noinst_PROGRAMS = check_dhcp check_icmp @EXTRAS_ROOT@
 
@@ -66,8 +66,11 @@
 
 ##############################################################################
 # the actual targets
-check_dhcp_LDADD = $(NETLIBS)
-check_icmp_LDADD = $(NETLIBS) $(SOCKETLIBS)
+check_dhcp_LDADD = @LTLIBINTL@ $(NETLIBS)
+check_icmp_LDADD = @LTLIBINTL@ $(NETLIBS) $(SOCKETLIBS)
+# -m64 needed at compiler and linker phase
+pst3_CFLAGS = @PST3CFLAGS@
+pst3_LDFLAGS = @PST3CFLAGS@
 pst3_LDADD = -lkvm
 
 check_dhcp_DEPENDENCIES = check_dhcp.c $(NETOBJS) $(DEPLIBS) 
diff -uNr nagios-plugins-1.4.11/plugins-root/pst3.c nagios-plugins-1.4.12/plugins-root/pst3.c
--- nagios-plugins-1.4.11/plugins-root/pst3.c	2005-09-22 11:43:12.000000000 +0200
+++ nagios-plugins-1.4.12/plugins-root/pst3.c	2008-05-27 15:35:59.000000000 +0200
@@ -1,15 +1,15 @@
 /*	pst3.c
- *
- *  Third version to get process arg info; this time by using
- *  a combination of reading the /proc/<pid>/psinfo structures
- *  and reading the complete arg vector from kernel memory structures.
- *
- *  Developed and tested under Solaris 5.8 (both 32 and 64 bit modes).
- *
- *  NOTE:  This program must be setuid-root (or run by root) to work!
- *
- *	Written: 2005-04-28	R.W.Ingraham
- */
+*
+*  Third version to get process arg info; this time by using
+*  a combination of reading the /proc/<pid>/psinfo structures
+*  and reading the complete arg vector from kernel memory structures.
+*
+*  Developed and tested under Solaris 5.8 (both 32 and 64 bit modes).
+*
+*  NOTE:  This program must be setuid-root (or run by root) to work!
+*
+*	Written: 2005-04-28	R.W.Ingraham
+*/
 
 
 #define _KMEMUSER	1
@@ -99,7 +99,7 @@
 	if ((pDir = opendir(PROC_DIR)) != NULL)
 	{
 		/* Display column headings */
-		printf("S   UID  PPID    VSZ    RSS %%CPU COMMAND ARGS\n");
+		printf("S   UID   PID  PPID    VSZ    RSS %%CPU COMMAND ARGS\n");
 
 		/* Zip through all of the process entries */
 		while ((pDent = readdir(pDir)) != NULL)
@@ -187,9 +187,10 @@
 			thisProg = myArgv[0];
  
 		/* Display the ps columns (except for argv) */
-		printf("%c %5d %5d %6lu %6lu %4.1f %s ",
+		printf("%c %5d %5d %5d %6lu %6lu %4.1f %s ",
 			pPsInfo->pr_lwp.pr_sname,
 			(int)(pPsInfo->pr_euid),
+			(int)(pPsInfo->pr_pid),
 			(int)(pPsInfo->pr_ppid),
 			(unsigned long)(pPsInfo->pr_size),
 			(unsigned long)(pPsInfo->pr_rssize),
diff -uNr nagios-plugins-1.4.11/po/Makevars nagios-plugins-1.4.12/po/Makevars
--- nagios-plugins-1.4.11/po/Makevars	2007-02-06 19:34:33.000000000 +0100
+++ nagios-plugins-1.4.12/po/Makevars	2008-02-12 12:07:18.000000000 +0100
@@ -8,7 +8,7 @@
 top_builddir = ..
 
 # These options get passed to xgettext.
-XGETTEXT_OPTIONS = --keyword=_ --keyword=N_
+XGETTEXT_OPTIONS = --keyword=_ --keyword=N_ --flag=error:3:c-format --flag=error_at_line:5:c-format --flag=asprintf:2:c-format --flag=vasprintf:2:c-format
 
 # This is the copyright holder that gets inserted into the header of the
 # $(DOMAIN).pot file.  Set this to the copyright holder of the surrounding
diff -uNr nagios-plugins-1.4.11/REQUIREMENTS nagios-plugins-1.4.12/REQUIREMENTS
--- nagios-plugins-1.4.11/REQUIREMENTS	2007-09-23 13:03:33.000000000 +0200
+++ nagios-plugins-1.4.12/REQUIREMENTS	2008-05-23 11:09:17.000000000 +0200
@@ -7,6 +7,10 @@
 usually not compiled.  Requirements for various plugins are listed
 below...
 
+check_ldaps, check_http --ssl, check_tcp --ssl, check_smtp --starttls
+	- Requires openssl or gnutls libraries for SSL connections
+	  http://www.openssl.org, http://www.gnu.org/software/gnutls
+
 check_fping:
 	- Requires the fping utility distributed with SATAN.  Either
 	  download and install SATAN or grab the fping program from
@@ -43,11 +47,14 @@
 	  http://www.postgresql.org/
 
 check_radius:
-	- Requires the radiusclient library available from
+	- Requires the radiusclient-ng library available from:
+	  http://developer.berlios.de/projects/radiusclient-ng/
+	- This plugin also works with the original radiusclient library from
 	  ftp://ftp.cityline.net/pub/radiusclient/
 		RPM (rpmfind): radiusclient 0.3.2, radiusclient-devel-0.3.2
-	- Alternatively radiusclient-ng can be used:
-	  http://developer.berlios.de/projects/radiusclient-ng/
+	  Unless you're using a distro-maintained version of this library you
+	  probably want to use radiusclient-ng. The original radiusclient library is
+	  unmaintained and has many known issues, particularly with 64bit systems.
 
 check_snmp:
 	- Requires the NET-SNMP package available from
diff -uNr nagios-plugins-1.4.11/THANKS nagios-plugins-1.4.12/THANKS
--- nagios-plugins-1.4.11/THANKS	2007-12-13 23:43:49.000000000 +0100
+++ nagios-plugins-1.4.12/THANKS	2008-05-28 00:06:09.000000000 +0200
@@ -107,6 +107,7 @@
 Bob Ingraham
 Cire Iriarte
 Valdimir Ivaschenko
+Harald Jenny
 Mark Jewiss
 Frank Kannemann
 Roy Sigurd Karlsbakk
@@ -172,6 +173,7 @@
 Phil Randal
 Abid Rasheed
 Jeremy Reed
+Alessandro Ren
 Joe Rhett
 Cliff Rice
 Alain Richard
@@ -190,6 +192,7 @@
 Thomas Schimpke
 Benjamin Schmid
 Henning Schmiedehausen
+Christian Schneemann
 Cove Schneider
 Enrico Scholz
 Sebastian Schubert
@@ -212,6 +215,7 @@
 Julien Touche
 Kyle Tucker
 Jerome Tytgat
+Matthias Urlichs
 Matteo HCE Valsasna
 Jon Vandegrift
 Laurent Vaslin
@@ -220,6 +224,7 @@
 Robert August Vincent
 Dave Viner
 Nathan Vonnahme
+Jan Wagner
 John Warburton
 Christian G Warden
 Stuart Webster
@@ -231,5 +236,6 @@
 Paul Wiggins
 Howard Wilkinson
 Shawn Wills
+Rob Windsor
 Mario Witte
 Jamie Zawinski
diff -uNr nagios-plugins-1.4.11/tools/build_perl_modules nagios-plugins-1.4.12/tools/build_perl_modules
--- nagios-plugins-1.4.11/tools/build_perl_modules	2007-09-13 13:36:57.000000000 +0200
+++ nagios-plugins-1.4.12/tools/build_perl_modules	2008-02-28 13:54:49.000000000 +0100
@@ -74,7 +74,9 @@
 	chdir $dir or die "Can't chdir into $dir";
 
 	# Need to add this so this module is found for subsequent ones
-	$ENV{PERL5LIB}="$topdir/$dir/blib/lib:$ENV{PERL5LIB}";
+	my @dirs = split(":", $ENV{PERL5LIB} || "");
+	unshift @dirs, "$topdir/$dir/blib/lib";
+	$ENV{PERL5LIB}=join(":", @dirs);
 
 	if ($opts->{t}) {
 		system("make test") == 0 or die "Can't run make test failed";
diff -uNr nagios-plugins-1.4.11/tools/tinderbox_build nagios-plugins-1.4.12/tools/tinderbox_build
--- nagios-plugins-1.4.11/tools/tinderbox_build	2007-12-12 02:27:48.000000000 +0100
+++ nagios-plugins-1.4.12/tools/tinderbox_build	2008-01-09 05:27:52.000000000 +0100
@@ -14,7 +14,7 @@
 use Cwd;
 use Time::Local;
 
-my $Version = '$Revision: 1866 $';
+my $Version = '$Revision: 1904 $';
 
 my $myhost = hostname;
 chomp($myhost);
@@ -266,8 +266,8 @@
 
 sub maketest {
         # Tests
-        print LOG "LANG=C make test-debug 2>&1\n";
-        open( MAKE, "LANG=C make test-debug && make install DESTDIR=$TmpDir/tinderbox_build.$$ && make install-strip DESTDIR=$TmpDir/tinderbox_build2.$$ 2>&1 |");
+        print LOG "LANG=C make test 2>&1\n";
+        open( MAKE, "LANG=C make test && make install DESTDIR=$TmpDir/tinderbox_build.$$ && make install-strip DESTDIR=$TmpDir/tinderbox_build2.$$ 2>&1 |");
 	while ( <MAKE> ) {
 		print $_;
 		print LOG $_;
